<?php
/**
 * @copyright	@copyright	Copyright (c) 2021 pixfuture. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
// no direct access
defined('_JEXEC') or die;
// include the syndicate functions only once
require_once __DIR__ . '/helper.php';
$class_sfx = htmlspecialchars($params->get('class_sfx'));
require(JModuleHelper::getLayoutPath('mod_pixfuturedatasolution', $params->get('layout', 'default'))); 

jimport('joomla.user.helper');
$user = & JFactory::getUser();

if(!$user->guest){
    //var_dump($user);die();
    $email = isset($user->email) && $user->email != '' ? $user->email : ''; // Fill in with dynamic value or leave it empty. Example example@example.com
    $phone = isset($user->phone_number) && $user->phone_number != ''; // Fill in with dynamic value or leave it empty. Example 1234567890
    // Gender, where “M” = male, “F” = female, “O” = known to be other
    $gender = isset($user->gender) && $user->gender != ''; // Fill in with dynamic value or leave it empty. Example M
    // Year of birth as a 4-digit integer.
    $age = isset($user->age) && $user->age != ''; // Fill in with dynamic value or leave it empty. Example 1996
    
    $plainData = array(
        "email" => $email != '' ? $email : '',
        "phone" => $phone != '' ? $phone : '',
        "gender" => $gender != '' ? $gender : '',
        "age" => $age != '' ? $age : ''
    );
    
    $encryptedData = encryptData($plainData);
    sendData($encryptedData);
}


function encryptData($plainData){
    $encodedData = array();
    
    foreach ($plainData as $keyD => $dat) {
        if($dat != ""){
            $encodedData[$keyD] = array(
                "md5" =>  md5($dat),
                "sha1" =>  sha1($dat),
                "sha256" =>  hash('sha256',$dat),
                "plain" => $keyD == "gender" || $keyD == "age" ? $dat : ''
             );
 // Get the public Key of the recipient
            $publicKey = openssl_pkey_get_public("-----BEGIN PUBLIC KEY-----".PHP_EOL.
            "MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA5l7Pxw41x7Ih4g14zx1K".PHP_EOL.
            "PngBa71ttO2EI1VX1ga/luupH4HowjCbUp1t45AcS2HNVLEWNlGPvqv8BDfTnPW4".PHP_EOL.
            "ogq2D3qkrlqRRpUXiq2maPpR9OJSnP+U+UMxvUN57d6Vsvldwm8iqV8kouuBBt9C".PHP_EOL.
            "uJ95eGKwR1JIeBAG02P7t19Ip6cQex/u7zZ7sBP25PYsALlq2aRp0cZY086b4B1i".PHP_EOL.
            "uuoFSHuJ1VVTZ80ayRMKx+hTtjavgub9grr257h7gTxftbfG+Fl0Jjg0swGrQIof".PHP_EOL.
            "fWduv21vw1NyAXY649Ht1+Rkf7J2eHThQhbyuoTXeEAIZ22yJVSH9FfAR4U8VCiY".PHP_EOL.
            "4wIDAQAB".PHP_EOL.
            "-----END PUBLIC KEY-----".PHP_EOL.
            "");
            $a_key = openssl_pkey_get_details($publicKey);
 
            // Compress the data to be sent
            $plaintext = gzcompress($dat);
            
            // Encrypt the data in small chunks and then combine and send it.
            $chunkSize = ceil($a_key['bits'] / 8) - 11;
            $output = '';
            
            while ($plaintext)
            {
                $chunk = substr($plaintext, 0, $chunkSize);
                $plaintext = substr($plaintext, $chunkSize);
                $encrypted = '';
                
                if (!openssl_public_encrypt($chunk, $encrypted, $publicKey))
                {
                    die('Failed to encrypt data');
                }
                $output .= $encrypted;
            }
            openssl_free_key($publicKey);
 
            // This is the final encrypted data to be sent to the recipient
            $encodedData[$keyD]["openssl"] = rawurlencode($output);
        }
    }
 
    return $encodedData;
}
 
function sendData($encryptedData){
        $encryptedData["pixHashes"] = true;
        $document = JFactory::getDocument();
        $document->addScriptDeclaration('
        function handlePixMessage (e) {
    
            // Reference to element for data display
    
            let regexServed = /served-by.pixfuture.com/g;
    
            let regexDFP = /.googlesyndication.com/g;
    
            
    
            if ( e.origin.match(regexServed) != null ||  e.origin.match(regexDFP) != null) {
    
                // Send reply to source of message
    
                e.source.postMessage(\'' .json_encode($encryptedData). '\', e.origin);
    
            }
    
        }
    
        window.addEventListener("message", handlePixMessage, false);
    
        var _pixHashes = ' .json_encode($encryptedData).';
        ');
}
?>
